CommandBase (Apache ZooKeeper - Server 3.7.0 API)
Date: 2021-03-17

org.apache.zookeeper.server.admin

## Class CommandBase

- java.lang.Object
- - org.apache.zookeeper.server.admin.CommandBase

- All Implemented Interfaces:
    Command
  Direct Known Subclasses:
    Commands.CnxnStatResetCommand, Commands.ConfCommand, Commands.ConsCommand, Commands.DigestCommand, Commands.DirsCommand, Commands.DumpCommand, Commands.EnvCommand, Commands.GetTraceMaskCommand, Commands.InitialConfigurationCommand, Commands.IsroCommand, Commands.LastSnapshotCommand, Commands.LeaderCommand, Commands.MonitorCommand, Commands.ObserverCnxnStatResetCommand, Commands.RuokCommand, Commands.SetTraceMaskCommand, Commands.SrvrCommand, Commands.StatResetCommand, Commands.SyncedObserverConsCommand, Commands.SystemPropertiesCommand, Commands.VotingViewCommand, Commands.WatchCommand, Commands.WatchesByPathCommand, Commands.WatchSummaryCommand, Commands.ZabStateCommand

      public abstract class CommandBase
      extends Object
      implements Command

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `CommandBase(List<String> names)`
    `protected` | `CommandBase(List<String> names, boolean serverRequired)`
    `protected` | `CommandBase(List<String> names, boolean serverRequired, String doc)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `getDoc()` A string documenting this command (e.g., what it does, any arguments it takes).
    `Set<String>` | `getNames()` The set of all names that can be used to refer to this command (e.g., "configuration", "config", and "conf").
    `String` | `getPrimaryName()` The name that is returned with the command response and that appears in the list of all commands.
    `protected CommandResponse` | `initializeResponse()`
    `boolean` | `isServerRequired()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.zookeeper.server.admin.Command

      `run`

- - ### Constructor Detail

    - #### CommandBase

          protected CommandBase(List<String> names)

      Parameters:
        `names` - The possible names of this command, with the primary name first.

    - #### CommandBase

          protected CommandBase(List<String> names,
                                boolean serverRequired)

    - #### CommandBase

          protected CommandBase(List<String> names,
                                boolean serverRequired,
                                String doc)

  - ### Method Detail

    - #### getPrimaryName

          public String getPrimaryName()

      Description copied from interface: `Command`
      The name that is returned with the command response and that appears in the list of all commands. This should be a member of the set returned by getNames().
      Specified by:
        `getPrimaryName` in interface `Command`

    - #### getNames

          public Set<String> getNames()

      Description copied from interface: `Command`
      The set of all names that can be used to refer to this command (e.g., "configuration", "config", and "conf").
      Specified by:
        `getNames` in interface `Command`

    - #### getDoc

          public String getDoc()

      Description copied from interface: `Command`
      A string documenting this command (e.g., what it does, any arguments it takes).
      Specified by:
        `getDoc` in interface `Command`

    - #### isServerRequired

          public boolean isServerRequired()

      Specified by:
        `isServerRequired` in interface `Command`
      Returns:
        true if the command requires an active ZooKeeperServer or a synced peer in order to resolve

    - #### initializeResponse

          protected CommandResponse initializeResponse()

      Returns:
        A response with the command set to the primary name and the error set to null (these are the two entries that all command responses are required to include).

Copyright © 2008–2021 The Apache Software Foundation. All rights reserved.